/*
<This program is a text editor ebable of transcription on text file.>
<Ce programme est un éditeur de texte capable de chiffrement sur des fichier texte.>
Copyright (C) 2008 Keven Chaussé
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef HEADER_CRYPTEUR
#define HEADER_CRYPTEUR

#include <QMessageBox>
#include "Decrypteur.h"


class Crypteur  : public FenCryptographe
{
	public:

		Crypteur(QString texte, FenCryptographe *parent = NULL); // Constructeur principal
		void setQString(QString texte);
		void setParent(FenCryptographe *parent);
		bool convertionAZaz();
		QList<int> comporteASCII(QString* texte);
		bool AZazOnly(QString* texte);
		int getRandomInt(int min, int max);
		int compteLettreAZaz();
		void initialRandom();

        /// METHODES DE CHIFFREMENT
		QString* chiffrer();

            // SOUS METHODES DE CHIFFREMENT
            bool cesarC();
            bool rot13C(int nombre = 13, int methode = 0);
            bool vigenereC();
            bool vernamC();

        /// METHODE DE DECHIFFREMENT
		QString* dechiffrer();

            // SOUS METHODES DE DECHIFFREMENT
            bool cesarD();
            bool rot13D();
            bool vigenereD();
            bool vernamD();

        /// METHODE DE DECRYPTION
		void decrypter();

            // SOUS METHODES DE DECRYPTION


	private:

        QString *m_texte;
        QString *resultatDecryption;
        QMessageBox testing;
        FenCryptographe *m_parent;
        Decrypteur *decrypteur;
};

#endif
