/*
<This program is a text editor ebable of transcription on text file.>
<Ce programme est un éditeur de texte capable de chiffrement sur des fichier texte.>
Copyright (C) 2008 Keven Chaussé
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef HEADER_FENCRYPTOGRAPHE
#define HEADER_FENCRYPTOGRAPHE

#include <QtGui>
#include <QTextEdit>
#include <QProgressBar>
#include "ui_cryptographe.h"
#include "ui_cryptopedia.h"

class FenCryptographe : public QMainWindow, private Ui::FenCryptographe
{
    Q_OBJECT

	public:

		FenCryptographe(QMainWindow *parent = 0); // Constructeur principal

        QTextEdit* documentActuel();            // Renvoie un pointeur sur l'objet QTextEdit contenu dans un onglet
        int ongletActuel();
        void setOnglets(int);


    private:

        /// FONCTIONS D'INITIALISATION
            void creerActions();
            void creerBarreEtat();

        /// AUTRE FONCTIONS
        void setEnabledAction(bool enabled);    // Active ou Désactive certaine action

    /// SIGNALS

    signals:

        void ongletsExiste(bool existe);    // Signal emit lorsque les onglets sont tous fermé, pour la désactivation des actions


        /// SLOTS FICHIER

        public slots:

            void creerDocument();
            void enregistrerDocumentSous();

        private slots:

            void ouvrirDocument();
            bool enregistrerDocument();    // Toutes les fonctions d'ouverture, fermeture de programme
            void fermerDocument(bool);          // Ainsi que imprimer un document
            void fermerToutDocuments();
            void imprimer();

            // SOUS SLOTS FICHIER
                QWidget* creerOnglet(QFile* fichier = NULL);
                void modifierFichier();
                void changementOnglets(int);
                bool verificationFichierSave();

        /// SLOTS ÉDITION
            void annuler();
            void repeter();
            void couper();
            void copier();
            void coller();
            void selectionnerTout();        // Toutes les fonctions habituel d'un éditeur de texte
            void rechercher();
            void changerPreferences();

            // SOUS SLOTS ÉDITION
                void changementRedo(bool);
                void changementUndo(bool);
                void changementCopy(bool);

        /// SLOTS OUTILS
            void chiffrer();
            void dechiffrer();  // Outils de Cryptographie
            void decrypter();
            void ordreAlpha();

        /// SLOTS INFORMATION
            void informationCrypto(); // Information sur la cryptographie
            void aboutKC();


        /// METHODES SURCHARGÉS
    protected:

        virtual void closeEvent(QCloseEvent *event); // Methode surchargé afin de vérifier la sauvegarde avant la fermeture du programme


	private:

        int nombreFichier;      // utilisé dans le système de changement de nom d'un nouveau fichier

        QWidget *zoneCentrale;

        QTabWidget *onglets;
        QTabWidget *information;

        QProgressBar *progression;              // Quelques objet globale

        QList<QString> *listeEmplacement;

        QList<bool> *modificationFichier;
        QList<bool> *nomModifier;
        QList<bool> *isRedoAvailable;
        QList<bool> *isUndoAvailable;
        QList<bool> *isCopyAvailable;

        QDialog *crypto;
};

#endif
